#include <bits/stdc++.h>

using namespace std;

bool proveri(string s)
{
    int n = s.length();
    for(int i = 0; i <= n/2; i++)
        if((s[i]!=s[n-i-1])||s[i]=='0')
            return false;
    return true;
}

int main()
{
    int n, q;
    cin >> n >> q;
    string s = "0";
    for(int i = 1; i < n; i++)
        s+="0";
    for(int i = 0; i < q; i++)
    {
        int t;
        cin >> t;
        if(t == 1)
        {
            int u, v;
            char c;
            cin >> u >> v >> c;
            s[u] = c;
        }
        if(t == 2)
        {
            int u, v;
            cin >> u >> v;
            if(u > v)
                swap(u, v);
            cout << proveri(s.substr(u, v-u));
        }
    }
    return 0;
}